/** @license React v16.4.0
 * react-test-renderer-shallow.production.min.js
 *
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';var e=require("object-assign"),f=require("fbjs/lib/invariant"),l=require("react"),m=require("react-is"),n=require("fbjs/lib/emptyObject"),p=require("fbjs/lib/shallowEqual"),q=require("prop-types/checkPropTypes");
function r(b){for(var a=arguments.length-1,c="https://reactjs.org/docs/error-decoder.html?invariant="+b,d=0;d<a;d++)c+="&args[]="+encodeURIComponent(arguments[d+1]);f(!1,"Minified React error #"+b+"; visit %s for the full message or use the non-minified dev environment for full errors and additional helpful warnings. ",c)}
var t="function"===typeof Symbol&&Symbol.for,u=t?Symbol.for("react.portal"):60106,x=t?Symbol.for("react.fragment"):60107,y=t?Symbol.for("react.strict_mode"):60108,z=t?Symbol.for("react.profiler"):60114,A=t?Symbol.for("react.provider"):60109,B=t?Symbol.for("react.context"):60110,C=t?Symbol.for("react.async_mode"):60111,D=t?Symbol.for("react.forward_ref"):60112,E=t?Symbol.for("react.timeout"):60113;
function F(b){var a=b.type;if("function"===typeof a)return a.displayName||a.name;if("string"===typeof a)return a;switch(a){case C:return"AsyncMode";case B:return"Context.Consumer";case x:return"ReactFragment";case u:return"ReactPortal";case z:return"Profiler("+b.pendingProps.id+")";case A:return"Context.Provider";case y:return"StrictMode";case E:return"Timeout"}if("object"===typeof a&&null!==a)switch(a.$$typeof){case D:return b=a.render.displayName||a.render.name||"",""!==b?"ForwardRef("+b+")":"ForwardRef"}return null}
function G(b,a){if(!(b instanceof a))throw new TypeError("Cannot call a class as a function");}
var K=function(){function b(){G(this,b);this._rendered=this._newState=this._instance=this._element=this._context=null;this._forcedUpdate=this._rendering=!1;this._updater=new H(this)}b.prototype.getMountedInstance=function(){return this._instance};b.prototype.getRenderOutput=function(){return this._rendered};b.prototype.render=function(a){var c=1<arguments.length&&void 0!==arguments[1]?arguments[1]:n;l.isValidElement(a)?void 0:r("12","function"===typeof a?" Instead of passing a component class, make sure to instantiate it by passing it to React.createElement.":
"");"string"===typeof a.type?r("13",a.type):void 0;m.isForwardRef(a)||"function"===typeof a.type?void 0:r("249",Array.isArray(a.type)?"array":null===a.type?"null":typeof a.type);if(!this._rendering){this._rendering=!0;this._element=a;var d=a.type.contextTypes;if(d){var b={},g;for(g in d)b[g]=c[g];c=b}else c=n;this._context=c;this._instance?this._updateClassComponent(a,this._context):m.isForwardRef(a)?this._rendered=a.type.render(a.props,a.ref):(c=a.type,c.prototype&&c.prototype.isReactComponent?(this._instance=
new a.type(a.props,this._context,this._updater),this._updateStateFromStaticLifecycle(a.props),a.type.hasOwnProperty("contextTypes")&&(I=a,c=a.type,d=(d=this._instance)&&d.constructor,q(a.type.contextTypes,this._context,"context",c.displayName||d&&d.displayName||c.name||d&&d.name||null,J),I=null),this._mountClassComponent(a,this._context)):this._rendered=a.type(a.props,this._context));this._rendering=!1;this._updater._invokeCallbacks();return this.getRenderOutput()}};b.prototype.unmount=function(){this._instance&&
"function"===typeof this._instance.componentWillUnmount&&this._instance.componentWillUnmount();this._instance=this._rendered=this._newState=this._element=this._context=null};b.prototype._mountClassComponent=function(a,c){this._instance.context=c;this._instance.props=a.props;this._instance.state=this._instance.state||null;this._instance.updater=this._updater;if("function"===typeof this._instance.UNSAFE_componentWillMount||"function"===typeof this._instance.componentWillMount)c=this._newState,"function"!==
typeof a.type.getDerivedStateFromProps&&"function"!==typeof this._instance.getSnapshotBeforeUpdate&&("function"===typeof this._instance.componentWillMount&&this._instance.componentWillMount(),"function"===typeof this._instance.UNSAFE_componentWillMount&&this._instance.UNSAFE_componentWillMount()),c!==this._newState&&(this._instance.state=this._newState||n);this._rendered=this._instance.render()};b.prototype._updateClassComponent=function(a,c){var b=a.props,v=a.type,g=this._instance.state||n,w=this._instance.props;
w!==b&&"function"!==typeof a.type.getDerivedStateFromProps&&"function"!==typeof this._instance.getSnapshotBeforeUpdate&&("function"===typeof this._instance.componentWillReceiveProps&&this._instance.componentWillReceiveProps(b,c),"function"===typeof this._instance.UNSAFE_componentWillReceiveProps&&this._instance.UNSAFE_componentWillReceiveProps(b,c));this._updateStateFromStaticLifecycle(b);var h=this._newState||g,k=!0;this._forcedUpdate?(k=!0,this._forcedUpdate=!1):"function"===typeof this._instance.shouldComponentUpdate?
k=!!this._instance.shouldComponentUpdate(b,h,c):v.prototype&&v.prototype.isPureReactComponent&&(k=!p(w,b)||!p(g,h));k&&"function"!==typeof a.type.getDerivedStateFromProps&&"function"!==typeof this._instance.getSnapshotBeforeUpdate&&("function"===typeof this._instance.componentWillUpdate&&this._instance.componentWillUpdate(b,h,c),"function"===typeof this._instance.UNSAFE_componentWillUpdate&&this._instance.UNSAFE_componentWillUpdate(b,h,c));this._instance.context=c;this._instance.props=b;this._instance.state=
h;k&&(this._rendered=this._instance.render())};b.prototype._updateStateFromStaticLifecycle=function(a){var c=this._element.type;"function"===typeof c.getDerivedStateFromProps&&(a=c.getDerivedStateFromProps.call(null,a,this._instance.state),null!=a&&(a=e({},this._newState||this._instance.state,a),this._instance.state=this._newState=a))};return b}();K.createRenderer=function(){return new K};
var H=function(){function b(a){G(this,b);this._renderer=a;this._callbacks=[]}b.prototype._enqueueCallback=function(a,c){"function"===typeof a&&c&&this._callbacks.push({callback:a,publicInstance:c})};b.prototype._invokeCallbacks=function(){var a=this._callbacks;this._callbacks=[];a.forEach(function(a){a.callback.call(a.publicInstance)})};b.prototype.isMounted=function(){return!!this._renderer._element};b.prototype.enqueueForceUpdate=function(a,c){this._enqueueCallback(c,a);this._renderer._forcedUpdate=
!0;this._renderer.render(this._renderer._element,this._renderer._context)};b.prototype.enqueueReplaceState=function(a,c,b){this._enqueueCallback(b,a);this._renderer._newState=c;this._renderer.render(this._renderer._element,this._renderer._context)};b.prototype.enqueueSetState=function(a,b,d){this._enqueueCallback(d,a);d=this._renderer._newState||a.state;"function"===typeof b&&(b=b.call(a,d,a.props));null!==b&&void 0!==b&&(this._renderer._newState=e({},d,b),this._renderer.render(this._renderer._element,
this._renderer._context))};return b}(),I=null;function J(){var b="";if(I){var a=null==I?"#empty":"string"===typeof I||"number"===typeof I?"#text":"string"===typeof I.type?I.type:I.type.displayName||I.type.name||"Unknown",c=I._owner,d=I._source;c=c&&F(c);a="\n    in "+(a||"Unknown")+(d?" (at "+d.fileName.replace(/^.*[\\\/]/,"")+":"+d.lineNumber+")":c?" (created by "+c+")":"");b+=a}return b}var L={default:K},M=L&&K||L;module.exports=M.default?M.default:M;
